clear
close all

x = [0:.0001:1];
%  y = normpdf(x,0.5,0.1);
% y=y/(sum(y));

pd = makedist('Weibull','A',0.5,'B',5);
y = pdf(pd, x);
%y= pdf('Normal',x,0.5,0.1)
yyaxis left

plot(x,y,'LineWidth',1)
xlabel('\tau')
ylabel('PDF')
grid on, hold on
%line('XData', [0.5 0.5], 'YData', [0 y(5000)], 'LineWidth', 1, ...
%   'LineStyle', '-.', 'Color', 'black')
legend({'PDF'},'Location','northeast')
%t2 = text(0.225,max(y)/8,'JND threshold\rightarrow','FontSize',12,'Color','black')

%t2 = text(0.46,max(y)/5,'JND threshold','FontSize',12,'Color','black')
% set(t2,'Rotation',90);

%matlab2tikz('./PDF_weibull/PDF.tex','standalone',true);

%figure
hold on
x = [0:.0001:1];

p1 = cdf(pd,x);
%p = cdf(x,0.5,0.1)
yyaxis right

plot(x,p1, 'LineWidth',1,'Color','g')

p2=1-p1;
plot(x,p2, 'LineWidth',1,"LineStyle",'-', 'Color','r')

xlabel('\tau')
ylabel('CDF & SUR')

grid on
c=p1-p2;
c=abs(c);
loc=x(find(c==min(c)));

line('XData', [loc loc], 'YData', [0 max(p2)/2], 'LineWidth', 1, ...
    'LineStyle', '-.', 'Color', 'black')
line('XData', [loc 1], 'YData', [max(p2)/2 max(p2)/2], 'LineWidth', 1, ...
    'LineStyle', '-.', 'Color', 'black')

t2 = text(0.44,max(p2)/20,'JND threshold','FontSize',12,'Color','black');
set(t2,'Rotation',90);

t3 = text(0.8,(max(p2)/2+max(p2)/40),'CDF = 0.5','FontSize',12,'Color','black');

legend({'PDF', 'CDF','SUR'},'Location','northeast')
set(gca,'fontsize',14);
set(gca,'fontname','times')
hold off
matlab2tikz('./plots_statistics_BD/PDF_CDF_and_SUR2.tex', 'standalone', true);
saveas(gcf, './plots_statistics_BD/PDF_CDF_and_SUR2.pdf');
saveas(gcf, './plots_statistics_BD/PDF_CDF_and_SUR2.eps')
%pd = makedist('Weibull','A',5,'B',2)

