% mQUESTPlus 
%
% MATLAB implementation of Watson's QUEST+.
% 
% The method and Mathematica code are described in the paper: Watson, A. B.
% (2017).  "QUEST+: A general multidimensional Bayesian adaptive
% psychometric method". Journal of Vision, 17(3):10, 1-27,
% http://jov.arvojournals.org/article.aspx?articleid=2611972.
%
% See README.md in the mQUESTPlus repository root directory for more info
% (or read it on github at https://github.com/BrainardLab/mQUESTPlus).
%
% A good way to get started with mQUESTPlus is with the demos. See
% "help mQUESTPlus/demos" for a complete list. Two key demos are:
%
%   1) qpQuestPlusPaperSimpleExampleDemo.  This runs several of the basic
%   demonstrations from the Watson (2017) QUEST+ paper, showing usage for
%   function qpRun.
%
%   2) qpQuestPlusCoreFunctionDemo. This illustrates how you can call the
%   core functions of mQUESTPlus directly, rather than letting qpRun
%   orchestrate your experiment.
%
% contributed                   - Software (mostly demos) contributed by users
% dataproc                      - Functions for data manipulation
% demos                         - Demonstration/test programs.
% mathworkscentral              - Dependencies obtained from mathworks
%                                 central and other internet sources.
% printplot                     - Support for printing and plotting.
% psifunctions                  - Psychometric functions.
% questplus                     - The core QUEST+ routines.
% utilities                     - Support utilities.

