close all
figure; clf; hold on
set(gca,'Color',[1 1 1]*1.0);
stimCounts = qpCounts(qpData(questData.trialData),questData.nOutcomes);
stimProportions = qpProportions(stimCounts,questData.nOutcomes);
stim = zeros(length(stimCounts),questData.nStimParams);
for cc = 1:length(stimCounts)
    stim(cc,:) = stimCounts(cc).stim;
    nTrials(cc) = sum(stimCounts(cc).outcomeCounts);
end

cols = [240 133 125; 0 128 0; 149 246 136; 120 200 80]/255;
for cc = 1:length(stimCounts)
    for jj = 1:questData.nOutcomes
        switch (jj)
            case 1
                theColor = cols(1,:);
            case 2
                theColor = cols(2,:);
            case 3
                theColor = cols(3,:);
              case 4
                theColor = cols(4,:);
            otherwise
                error('Oops');
        end
    end
end
psiParamsIndex = qpListMaxArg(questData.posterior);
psiParamsQuest = questData.psiParamsDomain(psiParamsIndex,:);

psiParamsFit = qpFit(questData.trialData,questData.qpPF,psiParamsQuest,questData.nOutcomes,...
    'lowerBounds', [0 1.1 0.5 0],'upperBounds',[51 20 0.5 0.04]);
fprintf('Maximum likelihood fit parameters: %0.1f, %0.1f, %0.1f, %0.2f\n', ...
    psiParamsFit(1),psiParamsFit(2),psiParamsFit(3),psiParamsFit(4));

stimParams = linspace(0,51,52)';

plotStimParams = linspace(0,max(stimParams),52)';
outcomeProportions = qpPFWeibull(plotStimParams,psiParamsFit);
for jj = 1:1%length(psiParamsFit)
    plot([psiParamsFit(jj) psiParamsFit(jj)],[0 1],'k:','linewidth',2);
end

for i=1:size(outcomeProportions,2)
    plot(plotStimParams,outcomeProportions(:,i),'-','Color',cols(i,:),'LineWidth',3);
end

for i=1:1
    plot(plotStimParams,(outcomeProportions(:,i)-0.5)*2+1,'-.','Color',cols(i,:),'LineWidth',3);
end
for i=2:2
    plot(plotStimParams,(outcomeProportions(:,i)-0.5)*2,'-.','Color',cols(i,:),'LineWidth',3);
end
ylim([0 1]);
xlabel('stim value');
ylabel('Proportion');
title({'Simulated N Observers',''});
set(gca,'fontsize',10)
legend({'JND location','Psychometric function (No)','Psychometric function (Yes)','SUR','CDF'},'Location','east')

drawnow;
