function qpQuestPlusCoreFunctionDemoSimulationGroundTruthObservers
%qpQuestPlusCoreFunctionDemo  Show basic use of QUEST+ core functions, called directly
%
% Description:
%    his script shows how to call qpInitialize, qpQuery, and qpUpdate
%    directly.
clear all
clc

%% Initialize
%
% Set parameters, using key value pairs to override defaults
% as needed.  (See "help qpParams" for what is available.)
%
% Here we set the range for the stimulus (contrast in dB) and the
% psychometric function parameters (see qpPFWeibull_me).
%
% Note that the space on which the stimulus is gridded affects the
% prior used by QUEST+.  QUEST+ assigns equal probability to each
% listed stimulus, so that the prior implied if you grid contrast in
% dB is different from that if you grid contrast on a linear scale.
questDatam = qpInitialize('stimParamsDomainList',{[0:1:51]},'psiParamsDomainList',{0:51, 1.1:0.1:6, 0.5, 0:0.001:0.04});
%questData = qpInitialize('stimParamsDomainList',{[0:1:51]},'psiParamsDomainList',{0:51, 1:20, 0.5, 0});%0:0.005:0.02});


%% Set up simulated observer
%
% Parameters of the simulated Weibull
%simulatedPsiParams = [30, 5, .5, .02];

% Function handle that will take stimulus parameters x and simulate
% a trial according to the parameters above.
%simulatedObserverFun = @(x) qpSimulatedObserver(x,@qpPFWeibull,simulatedPsiParams);

% Freeze random number generator so output is repeatable
% rng('default'); rng(2004,'twister');
% threshold_std = 5;
% threshold_mean=30;
% thresholds = threshold_std.*randn(10000,1) + threshold_mean;
% %Normality test
% %KTest=(thresholds-threshold_mean)/threshold_std;
% %h = kstest(KTest)
%
% slope_min = 1.1;
% slope_max=6;
% p=6;
% n=10000;
% %slopes = slope_std.*randn(10000,1) + slope_mean;
% slopes= slope_min + (slope_max - slope_min)*sum(rand(n,p),2)/p;
%
% %Normality test
% %Ntest=(slopes-mean(slopes))/std(slopes);
% %h = kstest(Ntest);
%
% lapse_min = 0;
% lapse_max=0.04;
% p=6;
% n=10000;
% %lapses = lapse_std.*randn(10000,1) + lapse_mean;
% lapses= lapse_min + (lapse_max - lapse_min)*sum(rand(n,p),2)/p;
%
% %Normality test
% %Ntest=(lapses-mean(lapses))/std(lapses);
% %h = kstest(Ntest);
tic
rng(2004,'twister');
entropyThreshold=12;

threshold_min = 5;
threshold_max=43;
p=6;
n=50;
%thresholds = threshold_std.*randn(10000,1) + threshold_mean;
thresholds= (threshold_min + (threshold_max - threshold_min)*sum(rand(n,p),2)/p); %approximately normal

%Normality test
%KTest=(thresholds-mean(thresholds))/std(thresholds);
%h = kstest(KTest)
% inx=randperm(n);
% thresholds = thresholds(inx);
%

slope_min = 1.1;
slope_max=6;

%slopes = slope_std.*randn(10000,1) + slope_mean;
slopes= slope_min + (slope_max - slope_min)*sum(rand(n,p),2)/p; %normal
% inx=randperm(n);
%
% slopes = slopes(inx);
%Normality test
%Ntest=(slopes-mean(slopes))/std(slopes);
%h = kstest(Ntest);

lapse_min = 0;
lapse_max=0.04;
%lapses = lapse_std.*randn(10000,1) + lapse_mean;
lapses= lapse_min + (lapse_max - lapse_min)*sum(rand(n,p),2)/p;%normal

% inx=randperm(n);
%
% lapses = lapses(inx);
%Normality test
%Ntest=(lapses-mean(lapses))/std(lapses);
%h = kstest(Ntest);

outcomeProportions_all = zeros(52,2);

iterNumber = n;
PCs=0;
tic
for iteration =1 : iterNumber
    iteration
    PCs=PCs+1
    rng(iteration,'philox')
    % threshold_std = 5;
    % threshold_mean=26;
    % thresholds1 = round(threshold_std.*randn(10000,1) + threshold_mean);
    %KTest=(thresholds-threshold_mean)/threshold_std;
    
    questData = questDatam;
    
    %% Run simulated trials, using QUEST+ to tell us what contrast to
    %nTrials = 64;
    tt=1;
    
    observerIndex =  iteration;%randi([1 n],1,1);
    
    % Get stimulus for this trial
    simulatedPsiParams = [thresholds(observerIndex), slopes(observerIndex), 0.5, lapses(observerIndex)];
    simulatedObserverFun = @(x) qpSimulatedObserver(x,@qpPFWeibull,simulatedPsiParams);
    
    while 1
        
        stim = qpQuery(questData);
        
        % Simulate outcome
        outcome = simulatedObserverFun(stim);
        questData = qpUpdate(questData,stim,outcome);
        %     if outcome==1
        %             questData = qpUpdate(questData,stim,1);
        %             questData = qpUpdate(questData,stim,1);
        %             uu=uu+1;
        %     end
        %
        %     if outcome==2
        %             questData = qpUpdate(questData,stim,2);
        %             questData = qpUpdate(questData,stim,2);
        %             uu=uu+1;
        %     end
        % Update quest data structure
        %  questData = qpUpdate(questData,stim,outcome);
        if  questData.entropyAfterTrial(tt)<entropyThreshold % stopping crt.
            break;
        end
        stim_hist(tt)=stim;
        stim_resp(tt)=outcome;
        
        questData.entropyAfterTrial(tt)
        tt=tt+1
    end
    %save random_1000_observer_entropy
    
    %% Find out QUEST+'s estimate of the stimulus parameters, obtained
    % on the gridded parameter domain.
    psiParamsIndex = qpListMaxArg(questData.posterior);
    psiParamsQuest = questData.psiParamsDomain(psiParamsIndex,:);
    % fprintf('Simulated parameters: %0.1f, %0.1f, %0.1f, %0.2f\n', ...
    %     simulatedPsiParams(1),simulatedPsiParams(2),simulatedPsiParams(3),simulatedPsiParams(4));
    % fprintf('Max posterior QUEST+ parameters: %0.1f, %0.1f, %0.1f, %0.2f\n', ...
    %     psiParamsQuest(1),psiParamsQuest(2),psiParamsQuest(3),psiParamsQuest(4));
    
    %% Find aximum likelihood fit.  Use psiParams from QUEST+ as the starting
    % parameter for the search, and impose as parameter bounds the range
    % provided to QUEST+.
    psiParamsFit = qpFit(questData.trialData,questData.qpPF,psiParamsQuest,questData.nOutcomes,...
        'lowerBounds', [0 1.1 0.5 0],'upperBounds',[51 6 0.5 0.04]);
    % fprintf('Maximum likelihood fit parameters: %0.1f, %0.1f, %0.1f, %0.2f\n', ...
    %     psiParamsFit(1),psiParamsFit(2),psiParamsFit(3),psiParamsFit(4));
    
    % Little unit test that this routine still does what it used to.
    %psiParamsCheck = [-197856 20000 5000 0];
    %assert(all(psiParamsCheck == round(10000*psiParamsFit)),'No longer get same ML estimate for this case');
    
    
    %% Plot of trial locations with maximum likelihood fit
    
    stimCounts = qpCounts(qpData(questData.trialData),questData.nOutcomes);
    stimProportions = qpProportions(stimCounts,questData.nOutcomes);
    stim = zeros(length(stimCounts),questData.nStimParams);
    for cc = 1:length(stimCounts)
        stim(cc,:) = stimCounts(cc).stim;
        nTrials(cc) = sum(stimCounts(cc).outcomeCounts);
    end
    
    
%     psiParamsIndex = qpListMaxArg(questData.posterior);
%     psiParamsQuest = questData.psiParamsDomain(psiParamsIndex,:);
    
%     psiParamsFit = qpFit(questData.trialData,questData.qpPF,psiParamsQuest,questData.nOutcomes,...
%         'lowerBounds', [0 1.1 0.5 0],'upperBounds',[51 6 0.5 0.04]);
%     fprintf('Maximum likelihood fit parameters: %0.1f, %0.1f, %0.1f, %0.2f\n', ...
%         psiParamsFit(1),psiParamsFit(2),psiParamsFit(3),psiParamsFit(4));
    
    stimParams = linspace(0,51,52)';
    
    plotStimParams = linspace(0,max(stimParams),52)';
    outcomeProportions = qpPFWeibull(plotStimParams,psiParamsFit);
    
    outcomeProportions_all=outcomeProportions_all+outcomeProportions;
    simulatedPsiParams_all{PCs} = simulatedPsiParams;
    Observers_data{PCs} = outcomeProportions;
    total_PC(PCs) = tt;
    
end

outcomeProportions = outcomeProportions_all/iterNumber;
average_PC = sum(total_PC)/iterNumber

time =toc

close all
figure; clf; hold on
set(gca,'Color',[1 1 1]*1.0);
cols = [240 133 125; 0 128 0; 149 246 136; 120 200 80]/255;
% for cc = 1:length(stimCounts)
%     for jj = 1:questData.nOutcomes
%         switch (jj)
%             case 1
%                 theColor = cols(1,:);
%             case 2
%                 theColor = cols(2,:);
%             case 3
%                 theColor = cols(3,:);
%               case 4
%                 theColor = cols(4,:);
%             otherwise
%                 error('Oops');
%         end
%     end
% end


for jj = 1:1%length(psiParamsFit)
    plot([psiParamsFit(jj) psiParamsFit(jj)],[0 1],'k:','linewidth',2);
end

for i=1:size(outcomeProportions,2)
    plot(plotStimParams,outcomeProportions(:,i),'-','Color',cols(i,:),'LineWidth',3);
end

% for i=1:1
%     plot(plotStimParams,(outcomeProportions(:,i)-0.5)*2+1,'-.','Color',cols(i,:),'LineWidth',3);
% end
% for i=2:2
%     plot(plotStimParams,(outcomeProportions(:,i)-0.5)*2,'-.','Color',cols(i,:),'LineWidth',3);
% end
ylim([0 1]);
xlabel('stim value');
ylabel('Proportion');
title({'Simulated N Observers',''});
set(gca,'fontsize',10)
legend({'JND location','Psychometric function (No)','Psychometric function (Yes)'},'Location','east')

drawnow;
runTime = toc
save result_GroundTruthObservers_all