# Crowdsourced Estimation of Collective Just Noticeable Difference for Compressed Video with the Flicker Test and QUEST+

## Overview

This repository contains the source code and simulated data required to reproduce the simulations in our study. We've included the MATLAB code for those interested in replicating or extending our work. The focus of our research is on the crowdsourced estimation of the collective Just Noticeable Difference (JND) for compressed video sequences, utilizing the Flicker Test and QUEST+ methodology.

## Getting Started

### Prerequisites

- MATLAB installed on your system.

### Reproducing Figures

To reproduce the figures presented in our publication, follow these instructions:

- **Figures 1 and 2:** Execute the MATLAB files `Figure_1.m` and `Figure_2.m`.
- **Figures 3 and 4:** Run the file `Figure_3_and_Figure_4.m`.

These scripts use the simulated data stored in `Prob_Dist_all_1000_runs.mat`, which is provided at: https://datasets.vqa.mmsp-kn.de/archives/simulated_data_FlickerVidSet.zip

### Regenerating the Simulated Data

Although the simulated data (`Prob_Dist_all_1000_runs.mat`) is provided for convenience, you may wish to regenerate it to verify the results or conduct further analysis. To do so, follow these steps:

1. Execute the three MATLAB simulation scripts for the collective observer, average observer, and common approach: `simulation_collective_observer_parallel.m`, `simulation_average_observer_parallel.m`, and `simulation_relaxed_binary_search.m`. These scripts will generate three `.mat` files.
2. Run the `estimate_prob_distributions.m` script. This combines the three `.mat` files into the final `Prob_Dist_all_1000_runs.mat` simulated dataset.

## Problems / Bugs / Questions?

Should you encounter any problems or have questions, please feel free to contact me via email at mohsen.jenadeleh@uni-konstanz.de.

## License and Acknowledgements

FlickerVidSet is freely available to the research community. If you use our database or code in your research, please cite our paper:

@article{jenadeleh2023crowdsourced,
title={Crowdsourced Estimation of Collective Just Noticeable Difference for Compressed Video with Flicker Test and QUEST+},
author={Mohsen Jenadeleh, Raouf Hamzaoui, Ulf-Dietrich Reips, and Dietmar Saupe},
journal={TechRxiv preprint https://doi.org/10.36227/techrxiv.24119709.v1},
year={2023}
}

Our code incorporates other researchers' code for a MATLAB implementation of Quest+. The license for this code is described in the readme file located in the `mQUESTPlus` folder. Additionally, our code utilizes other libraries for plotting confidence intervals (CI) and generating `.tex` figures. The license for each of these codes is provided in the corresponding folder.
