function [threshold, num_comparisons] = relaxedBinarySearch(search_space, search_fun, varargin)
% Perform relaxed binary search
lower_bound = search_space(1);
upper_bound = search_space(end);

num_comparisons = 0;
flag= 1;
midpoint = floor((lower_bound + upper_bound) / 2);

while flag
    threshold = midpoint;

    % Evaluate the search function at the midpoint
    result = search_fun(midpoint, varargin{:});
    num_comparisons = num_comparisons + 1; % One comparison per iteration

    if result == 2
        % Update the upper bound
        if midpoint -lower_bound <= 1
            flag=0;
        else
            upper_bound = floor((lower_bound+ 3*upper_bound)/4);
            midpoint = floor((lower_bound + upper_bound) / 2);
        end
    else
        if upper_bound - midpoint <= 1
            flag=0;
        else
            % Update the lower bound
            lower_bound = ceil((3*lower_bound + upper_bound)/4);
            midpoint = ceil((lower_bound + upper_bound) / 2);

        end
    end
end
end


